/**
 * Test for apeman-ui-contrib-angular-decorating.
 * Runs with karma.
 */

"use strict";

var mock = angular.mock;

describe('apeman-ui-contrib-angular-decorating', function () {
    var ApDecorator,
        apDecorate;

    beforeEach(mock.module('apeman-ui-contrib-angular-decorating'));

    beforeEach(mock.inject(function (_ApDecorator_,
                                     _apDecorate_) {
        ApDecorator = _ApDecorator_;
        apDecorate = _apDecorate_;
    }));

    describe('ApDecorator', function () {
        it('Do decorate.', function () {
            var obj01 = {
                doSomething: function doSomething() {
                }
            };
            var decorator = new ApDecorator();
            expect(decorator).toBeDefined();
            decorator.decorate(obj01, 'doSomething', function defineDoSomething(origin) {
                return function doNothing() {

                };
            });
            expect(obj01.doSomething.name).toEqual('doNothing');
        });

        it('Un decoration.', function () {
            var obj02 = {
                doSomething: function doSomething() {
                }
            };
            var decorator = new ApDecorator();
            expect(decorator).toBeDefined();
            decorator
                .decorate(obj02, 'doSomething', function defineDoSomething(origin) {
                    return function doSomething2() {
                    };
                })
                .decorate(obj02, 'doSomething', function defineDoSomething(origin) {
                    return function doSomething3() {
                    };
                });
            expect(obj02.doSomething.name).toEqual('doSomething3');
            decorator.undoDecoration(obj02, 'doSomething');
            expect(obj02.doSomething.name).toEqual('doSomething2');
            decorator.undoAllDecorations(obj02, 'doSomething');
            expect(obj02.doSomething.name).toEqual('doSomething');
        });
    });

    describe('apDecorate', function () {
        it('Create a context.', function () {
            var decorator = apDecorate.create();
            expect(decorator).toBeDefined();
        });
    });
});